<!--#include file="common.asp" -->
<%
Call Main
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Sub Main
' This code determines if the form is in input or validation mode
' and calls the appropriate subroutine. 
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Sub Main
   Dim strAction  ' As String
   If Request(ACTION) = ACTION_VALIDATE Then
      ValidateData
   Else      
      ShowForm ""
   End If
End Sub
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Sub ShowForm
' This code shows the login form and any errors that may have 
' occurred on previous attempts to log into the system. 
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Sub ShowForm(strError)
   Session("UserID") = ""
   If strError <> "" Then
      WriteLine "<font color=#FF0000><b>" & strError & "</b></font>"
   End If
   WriteLine BuildValidateURL(ACTION_VALIDATE) 
   WriteLine "<input type=hidden name=oldURL value=""" & Request("oldURL") & """>"
   WriteLine "<table cellpadding=10><tr><td class=""cd"">User Name:"
   WriteLine "</td><td><input type=text size=20 name=txtUserName value=""" _
      & Request("txtUserName") & """></td></tr>" 
   WriteLine "<tr><td class=""cd"">Password:"
   WriteLine "</td><td><input type=password size=20 name=txtPassword></td></tr>" 
   WriteLine "<tr><td colspan=2 align=center><input type=submit name=cmdSubmit value=Login> "
   WriteLine "<input type=reset name=cmdReset value=Clear></td></tr></form>" 
   WriteLine "</table>" 
   WriteLine "<a href=""user.asp?" & ACTION & "=" & ACTION_REGISTER & """>Register</a></p>"
   'PrintFooter
End Sub
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Sub ValidateData
' This code checks the user's login information against the database
' and either logs them in or kicks back an error. 
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Sub ValidateData()
   Dim objUser    ' As MyObjects.User
   Dim lngUserID  ' As Long
   On Error Resume Next
   Set objUser = Server.CreateObject("MyObjects.User")
   lngUserID = objUser.Login (Request("txtUserName"), Request("txtPassword"))
   If Err.Number <> 0 Then
      ShowForm "ERROR: " & Err.description
   Else
      Session("UserID") = lngUserID
      If Request("oldURL") = "" Then
         Response.Redirect "frame.asp"
      Else
         Response.Redirect "frame.asp?oldurl=" & Request("oldURL")
      End If
   End If
End Sub
%>
There are a couple of constants and functions defined in common.asp that are relevant to this particular page:
Const ACTION = "a"
Const ACTION_VALIDATE = "v"
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Function BuildValidateURL
' This code builds the URL for a page to call to validate its input
' data. 
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function BuildValidateURL(strAction)
   BuildValidateURL = "<form action=""" & Request.ServerVariables("SCRIPT_NAME") _
      & "?" & ACTION & "=" & strAction & """ method=POST>"
End Function
